<template lang="pug">
centered(nomargintop).text-left
  div.columns
    //- Filters, sorting options
    dropdown-button(disabled) #[i.material-icons(tabindex="-1" style="font-size:0.9rem;") filter_list] {{ $t('filter by') }}
      template(slot="container")
        li.menu-item
          a.menu-item
            small {{ $t('date range') }}
        li.menu-item
          a.menu-item
            small {{ $t('publishing status') }}
    dropdown-button #[i.material-icons(tabindex="-1" style="font-size:0.9rem;") sort] {{ $t('sort by') }}
      template(slot="container")
        li.menu-item
          a.menu-item(@click="() => orderKey = 'created_at'")
            small {{ $t('most recently created first') }}
        li.menu-item
          a.menu-item(@click="() => orderKey = 'updated_at'")
            small {{ $t('most recently updated first') }} ({{ $t('default') }})
    button.btn.btn-link(@click="() => isInverted = !isInverted") #[i.material-icons(tabindex="-1" style="font-size:0.9rem;" title="Reverse order") swap_vert]
    input.form-input.account-corpora-search(
      v-model="search"
      type="search"
      :placeholder="$t('search')"
    )
    button.btn.btn-link(@click="resetFilters()") clear all #[i.material-icons(tabindex="-1" @click="resetFilters()" style="font-size:0.9rem;") cancel]

  //- List of corpora
  div.divider
  div.tile.mt-2(v-for="corpus in corpora.edges")
    div.tile-icon
      div.example-tile-icon
        i.material-icons(tabindex="-1") insert_drive_file
    div.tile-content
      nuxt-link.tile-title(
        :to="{ path: localePath({ name: 'corpus-id', params: { id: corpus.pk } } ) }"
      ) {{ corpus.title }}
      div
        small.tile-subtitle.text-gray.
          {{ corpus.files.length }} {{ $tc('file', corpus.files.length) }}
          ({{ corpus.files.map(file => file.size).reduce((accumulator, size) => accumulator + size, 0) | prettyBytes }})
          {{ corpus.draft ? '· ' : '' }}
          #[strong {{ corpus.draft ? $tc('draft', 1) : '' | capitalize }}]
          {{ corpus.commentsCount ? '· ' : '' }}
          {{ corpus.commentsCount ? `${corpus.commentsCount} ${$tc('comment', corpus.commentsCount)}` : '' | lowercase }}
      div
        small.tile-subtitle.text-gray.
          {{ $t('created') | lowercase }} {{ $d(new Date(corpus.createdAt), 'short') }} · 
          {{ $t('last updated') | lowercase }} #[timeago(:datetime="new Date(corpus.updatedAt)" :auto-update="20")]

    //- Actions for each corpus
    div.tile-action
      corpus-actions(:corpus="corpus" @afterDelete="() => $apollo.queries.corpora.refetch()")

  pagination.pagination(:index="1" :size="Math.ceil(corpora.edges.length / 10)" v-show="corpora.edges.length > baseQueryVariables.first")

  div(v-show="corpora.edges.length === 0")
    //- Empty state when fetching corpora
    .empty(v-if="$apollo.queries.corpora.loading || !initialized")
      spinner(:text="$t('fetching', { thing: $options.filters.lowercase($tc('corpus', 2)) })")
    //- Empty state when no corpora are found
    .empty(v-else="corpora.edges.length === 0")
      div(v-if="!search")
        no-data(height="200" primaryColor="rgba(var(--color-primary), 0.8)")
        p.empty-subtitle {{ $t('blank own corpora help') }}
        .empty-action
          nuxt-link(tabindex="-1" :to="{ path: localePath('account-corpora-create') }")
            z-button(size="sm") #[i.material-icons(style="position:relative;top:-1px;margin-right:0;") add] {{ $t('add a corpus') }}
      div(v-else)
        no-data(height="200" primaryColor="rgba(var(--color-primary), 0.8)")
        p.empty-subtitle {{ $t('cant find corpora') }}
        .empty-action
          z-button(size="sm" @click="resetFilters()") {{ $t('reset filters') }}
</template>

<script>
import Vue from 'vue'
import VueTimeago from 'vue-timeago'
import Vue2Filters from 'vue2-filters'

import NoData from 'vue-undraw/UndrawNoData'
import Centered from '~/components/sublayouts/Centered'
import Spinner from '~/components/Spinner.vue'
import CorpusCard from '~/components/CorpusCard'
import DropdownButton from '~/components/DropdownButton'
import CorpusActions from '~/components/CorpusActions'
import Pagination from '~/components/Pagination'

import listOwnCorporaGql from '~/apollo/queries/listOwnCorpora'
import { buildQuery, baseQueryVariables } from '~/apollo/queryBuilderCorpus'

Vue.use(VueTimeago, {
  name: 'Timeago'
})

export default {
  components: {
    Centered,
    Spinner,
    CorpusCard,
    DropdownButton,
    CorpusActions,
    Pagination,
    VueTimeago,
    NoData
  },
  mixins: [Vue2Filters.mixin],
  data() {
    return {
      initialized: false,
      baseQueryVariables,
      corpora: {
        edges: []
      },
      corporaFilter: {},
      search: '',
      isInverted: true,
      orderKey: 'updated_at'
    }
  },
  watch: {
    /* eslint-disable */
    '$route' (to, from) {
      this.parseQuery(to)
    }
  },
  apollo: {
    corpora: {
      ...buildQuery(listOwnCorporaGql),
      variables() {
        return {
          first: baseQueryVariables.first,
          title: this.search,
          orderBy: this.isInverted ? `-${this.orderKey}` : this.orderKey,
          ...this.corporaFilter
        }
      },
      update: data => {
        return {
          ...data.ownCorpora,
          edges: data.ownCorpora.edges.map(edge => edge.node)
        }
      },
      result({ data, loading, networkStatus }) {
        this.initialized = true
      }
    }
  },
  mounted() {
    this.parseQuery(this.$route)
  },
  methods: {
    resetFilters() {
      this.search = ''
      this.corporaFilter = {}
      this.isInverted = false
      this.orderKey = 'updatedAt'
    },
    parseQuery(route) {
      if (route.query.drafts === null) {
        this.corporaFilter = {
          onlyDrafts: true
        }
      } else if (route.query.pending === null) {
        this.corporaFilter = {
          onlyQuarantined: true
        }
      } else {
        this.corporaFilter = {}
      }
    }
  }
}
</script>

<style lang="postcss" scoped>
.card-parent:not(:first-child) {
  margin-top: 20px;
}
.card-parent {
  max-width: 400px;
}
.divider {
  margin-bottom: 1rem;
}
a.menu-item {
  display: flex;
  align-items: center;

  & i {
    margin-right: 0.3rem;
  }
}
.pagination {
  margin-top: 2rem;
  justify-content: center;
}
</style>

<style>
.account-corpora-search {
  width: auto;
  flex-grow: 3;
  background: none;
  border: none;
}
</style>
